﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.742.0/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (TcHmi) {
    var Functions;
    (function (Functions) {
        var SubscriptionLinking_Hemelix;
        (function (SubscriptionLinking_Hemelix) {
            function YardDoor(DeviceName, ControlName) {

                if (TcHmi.Server.isWebsocketReady()) {

                    console.log(`DeviceName = ${DeviceName}`);
                    console.log(`ControlName = ${ControlName}`);

                    var myControl = TcHmi.Controls.get(ControlName);
                    if (myControl) {

                        var proximityElipse = TcHmi.Controls.get(ControlName.concat('.TcHmi_Controls_Beckhoff_TcHmiEllipse_DoorProximity'));
                        var imagefield = TcHmi.Controls.get(ControlName.concat('.TcHmi_Controls_Beckhoff_TcHmiImage_Door'));

                        var motorOnElipse = TcHmi.Controls.get(ControlName.concat('.TcHmi_Controls_Beckhoff_TcHmiEllipse_MotorON'));
                        var motorBackElipse = TcHmi.Controls.get(ControlName.concat('.TcHmi_Controls_Beckhoff_TcHmiEllipse_MotorBack')); 
                        var timeElapse = TcHmi.Controls.get(ControlName.concat('.TcHmi_Controls_Beckhoff_TcHmiTextblock_7'));  
                        var currentState = 0;
                        var signalOFF = {

                            "color": "rgba(219, 216, 216, 1)",
                        };
                        var signalON = {

                            "color": "rgba(0, 255, 0, 1)",
                        };


                        var commands = [
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.isClosed'
                            },
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.obstackcleDetected'
                            },
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.closeAfter'
                            },
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.closeProximitySwitch'
                            },
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.timeElapsed'
                            },
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.currentState'
                            },
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.openYardDoorOutput'
                            },
                            {
                                'symbol': 'PLC1.MAIN.fnYardDoor.openYardDoorReverseOutput'
                            }
                        ];


                        TcHmi.Server.subscribe(commands, 500, function (data) {
                            if (data.error !== TcHmi.Errors.NONE) {
                                // Handle TcHmi.Server class level error here.
                                return;
                            }

                            var response = data.response;
                            if (!response || response.error !== undefined) {
                                // Handle TwinCAT HMI Server response level error here.
                                return;
                            }

                            var commands = response.commands;
                            if (commands === undefined) {
                                return;
                            }

                            for (var i = 0, ii = commands.length; i < ii; i++) {
                                var command = commands[i];
                                if (command === undefined) {
                                    return;
                                }
                                if (command.error !== undefined) {
                                    // Handle TwinCAT HMI Server command level error here.
                                    return;
                                }
                                 
                                    if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.isClosed') == 0) {
                                        if (command.readValue == true) {
                                            imagefield.setSrc('Images/MainDoor.svg');
                                            //imagefield.setOpacity(1);
                                        }
                                        console.log(`isClosed called = ${command.readValue}`);
                                    }

                                    if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.obstackcleDetected') == 0) {
                                        console.log(`obstackcleDetected called = ${command.readValue}`);
                                    }

                                    if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.closeAfter') == 0) {
                                        console.log(`closeAfter called = ${command.readValue}`);
                                    }
                                    if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.closeProximitySwitch') == 0) {
                                        if (command.readValue == true) {
                                            proximityElipse.setFillColor(signalON);
                                        }
                                        else {
                                            proximityElipse.setFillColor(signalOFF);
                                        }
                                        console.log(`closeProximitySwitch called = ${command.readValue}`);
                                    }

                                if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.timeElapsed') == 0) {
                                    var intval = command.readValue / 1000;
                                    timeElapse.setText(intval.toString());

                                    switch (currentState) {

                                        case 0: //closed
                                            {
                                                var t = [{
                                                    "transformType": "Translate",
                                                    "x": 0,
                                                    "xUnit": "px",
                                                    "y": 0,
                                                    "yUnit": "px",
                                                    "z": 0,
                                                    "zUnit": "px",
                                                }];
                                                imagefield.setTransform(t);

                                            }
                                            break;

                                        case 1: //opening
                                            {
                                                var t = [{
                                                    "transformType": "Translate",
                                                    "x": -intval * 20,
                                                    "xUnit": "px",
                                                    "y": 0,
                                                    "yUnit": "px",
                                                    "z": 0,
                                                    "zUnit": "px",
                                                }];
                                                imagefield.setTransform(t);

                                            }
                                            break;
                                        case 2: //opened
                                            {
                                                var t = [{
                                                    "transformType": "Translate",
                                                    "x": -200,
                                                    "xUnit": "px",
                                                    "y": 0,
                                                    "yUnit": "px",
                                                    "z": 0,
                                                    "zUnit": "px",
                                                }];
                                                imagefield.setTransform(t);
                                            }
                                            break;
                                        case 3: //closing
                                            {
                                                
                                                var t = [{
                                                    "transformType": "Translate",
                                                    "x": 20 * intval - 200,
                                                    "xUnit": "px",
                                                    "y": 0,
                                                    "yUnit": "px",
                                                    "z": 0,
                                                    "zUnit": "px",
                                                }];
                                                imagefield.setTransform(t);
                                            }
                                            break;
                                        default:
                                            break;
                                    }

                                        //console.log(`timeElapsed called = ${command.readValue}`);
                                    }


                                if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.currentState') == 0) {

                                    currentState = command.readValue;
                                    if (currentState == 2) {

                                        var t = [{
                                            "transformType": "Translate",
                                            "x": -200,
                                            "xUnit": "px",
                                            "y": 0,
                                            "yUnit": "px",
                                            "z": 0,
                                            "zUnit": "px",
                                        }];
                                        imagefield.setTransform(t);
                                    }
                                    console.log(`currentState called = ${command.readValue}`);
                                }

                                    if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.openYardDoorOutput') === 0) {
                                        console.log(`openYardDoorReverseOutput  command.readValue = ${command.readValue}`);
                                        if (command.readValue == true) {
                                            console.log(' openYardDoorOutput ON');
                                            motorOnElipse.setFillColor(signalON);
                                        }
                                        else {
                                            console.log(' openYardDoorOutput OFF');
                                            motorOnElipse.setFillColor(signalOFF);
                                        }
                                        console.log(`openYardDoorOutput called = ${command.readValue}`);
                                    }
                                    if (commands[i].symbol.localeCompare('PLC1.MAIN.fnYardDoor.openYardDoorReverseOutput') === 0) {
                                        console.log(`openYardDoorReverseOutput  command.readValue = ${command.readValue}`);
                                        if (command.readValue == true) {
                                            console.log(' openYardDoorReverseOutput ON');
                                            motorBackElipse.setFillColor(signalON);                                            
                                        }
                                        else {
                                            console.log(' openYardDoorReverseOutput OFF');
                                            motorBackElipse.setFillColor(signalOFF);
                                        }
                                        console.log(`openYardDoorReverseOutput called = ${command.readValue}`);
                                    }
                            }
                        }); //subscribe

                    } //myControl
                } //isWebsocketReady

            }
            SubscriptionLinking_Hemelix.YardDoor = YardDoor;
        })(SubscriptionLinking_Hemelix = Functions.SubscriptionLinking_Hemelix || (Functions.SubscriptionLinking_Hemelix = {}));
        Functions.registerFunctionEx('YardDoor', 'TcHmi.Functions.SubscriptionLinking_Hemelix', SubscriptionLinking_Hemelix.YardDoor);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);